#!/usr/bin/perl -w

// Listing 2: 
// Erzeugen eines Objekts zur
// Stream-Verarbeitung fr Mozilla & IE

// Variablen global vorbereiten
var http_request = null;
var startpos = 0;
var xmlpoll = null;

// XMLHttpRequest- bzw. htmlfile-Objekt erzeugen
if (navigator.userAgent.indexOf('MSIE') == -1 ||
    window.opera) {
  // Mozilla & Opera
  startpos = 0;
  http_request = new XMLHttpRequest();
  xmlpoll = window.setInterval(XHRPoll, 1000);
  http_request.onreadystatechange = parseResponse;
  http_request.open('GET', '/stream.pl', true);
  http_request.send(null);
} else {
  // Internet Explorer
  http_request = new ActiveXObject('htmlfile');
  http_request.open();
  http_request.write('<html><body></body></html>');
  http_request.close();
  // Funktionsaufruf-Brcken aus dem IFrame
  http_request.parentWindow.update = update;
  http_request.parentWindow.done = done;
  var body =
    http_request.getElementsByTagName('BODY')[0];
  body.innerHTML =
    "<iframe src='/stream.pl?IE'></iframe>";
}

// Aktualisierung der Anzeige
function update(msg) {
  document.getElementById('output').innerHTML = msg;
}

// Ende/Abbruch des Streams behandeln
function done() {
  http_request = null;
  window.clearInterval(xmlpoll);
}

// Polling-Funktion fr Mozilla/Opera
function XHRPoll() {
  var txt = http_request.responseText;
  var pos = txt.indexOf("\n", startpos);
  if (pos >= startpos) {
    update(txt.substring(startpos, pos));
    startpos = pos + 1;
  }
}

function parseResponse() {
  if (http_request.readyState == 4) {
    if (http_request.status == 200) {
      done();
    } else {
      alert('Fehler bei XMLHttpRequest: '
        + http_request.statusText + ')');
    }
    http_request = null;
    window.clearInterval(xmlpoll);
    running = 0;
  }
}
